"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var AmqpMessageBusModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.AmqpMessageBusModule = void 0;
const common_1 = require("@nestjs/common");
const amqp_message_bus_1 = require("../message-bus/amqp-message-bus");
const rabbitmq_client_1 = require("rabbitmq-client");
let AmqpMessageBusModule = AmqpMessageBusModule_1 = class AmqpMessageBusModule {
    static forRoot(options, isGlobal = true) {
        const defineBuses = () => {
            const result = [];
            for (const option of options) {
                result.push({
                    provide: option.name,
                    useFactory: () => {
                        return new amqp_message_bus_1.AmqpMessageBus(option.exchange, new rabbitmq_client_1.Connection(option.url), option.routingKey);
                    },
                });
            }
            return result;
        };
        return {
            global: isGlobal,
            module: AmqpMessageBusModule_1,
            providers: [
                ...defineBuses(),
            ],
            exports: [
                ...options.map(o => o.name),
            ],
        };
    }
};
exports.AmqpMessageBusModule = AmqpMessageBusModule;
exports.AmqpMessageBusModule = AmqpMessageBusModule = AmqpMessageBusModule_1 = __decorate([
    (0, common_1.Module)({})
], AmqpMessageBusModule);
//# sourceMappingURL=amqp-message-bus.module.js.map