"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MessageBus = exports.MessageHandler = void 0;
const microservices_1 = require("@nestjs/microservices");
const common_1 = require("@nestjs/common");
const MessageHandler = (routingKey) => {
    return function (target) {
        if (!target.prototype.handle) {
            throw new Error(`Class ${target.name} must implement a IMessageHandler interface.`);
        }
        Reflect.decorate([(0, microservices_1.EventPattern)(routingKey)], target.prototype, 'handle', Object.getOwnPropertyDescriptor(target.prototype, 'handle'));
    };
};
exports.MessageHandler = MessageHandler;
const MessageBus = (name) => (0, common_1.Inject)(name);
exports.MessageBus = MessageBus;
//# sourceMappingURL=decorator.js.map