"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AmqpTransport = void 0;
const microservices_1 = require("@nestjs/microservices");
const common_1 = require("@nestjs/common");
const rabbitmq_client_1 = require("rabbitmq-client");
const const_1 = require("../const");
let AmqpTransport = class AmqpTransport extends microservices_1.Server {
    options;
    client;
    constructor(options) {
        super();
        this.options = options;
        this.options.avoidNoHandlerError = options.avoidNoHandlerError ?? false;
        this.client = new rabbitmq_client_1.Connection(this.options.url);
    }
    on(event, callback) {
        throw new Error('Unimplemented');
    }
    unwrap() {
        throw new Error('Unimplemented');
    }
    async listen(callback) {
        await this.initialize();
        this.client.createConsumer({ queue: this.options.queue, queueOptions: { durable: true } }, async (msg) => {
            let message = msg.body;
            if (Buffer.isBuffer(message)) {
                message = JSON.parse(msg.body);
            }
            const headers = msg.headers;
            const routingKey = headers[const_1.RoutingKeyHeader] ?? msg.routingKey;
            const handler = this.messageHandlers.get(routingKey);
            if (this.options.avoidNoHandlerError || handler === undefined) {
                this.logger.error(`Handler for routingKey ${msg.routingKey} does not exist`);
                return;
            }
            handler(message);
        });
        callback();
    }
    async close() {
        await this.client.close();
    }
    async initialize() {
        if (!this.options.autoCreate) {
            return Promise.resolve();
        }
        await this.client.exchangeDeclare({ durable: true, exchange: this.options.exchange, type: this.options.exchangeType });
        await this.client.queueDeclare({ queue: this.options.queue, durable: true });
        for (const bindingKey of this.options.bindingKeys) {
            await this.client.queueBind({ routingKey: bindingKey, queue: this.options.queue, exchange: this.options.exchange });
        }
        return Promise.resolve();
    }
};
exports.AmqpTransport = AmqpTransport;
exports.AmqpTransport = AmqpTransport = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [Object])
], AmqpTransport);
//# sourceMappingURL=amqp.transport.js.map